

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.24. grn_thread_* &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.25.25. grn_type" href="grn_type.html" />
    <link rel="prev" title="7.25.23. grn_table_cursor" href="grn_table_cursor.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/api/grn_thread.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="grn_type.html" title="7.25.25. grn_type"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="grn_table_cursor.html" title="7.25.23. grn_table_cursor"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.24. </span><code class="docutils literal notranslate"><span class="pre">grn_thread_*</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-thread">
<h1><span class="section-number">7.25.24. </span><code class="docutils literal notranslate"><span class="pre">grn_thread_*</span></code><a class="headerlink" href="#grn-thread" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.24.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>スレッド関連のAPIには <code class="docutils literal notranslate"><span class="pre">grn_thread_</span></code> プレフィックスがついています。</p>
<p>通常、このAPIを使う必要はありません。</p>
<p>Groongaサーバーを実装するときにこのAPIを使いたくなるかもしれません。</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.24.2. </span>例<a class="headerlink" href="#example" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>以下は、 <a class="reference internal" href="../executables/groonga.html"><span class="doc">groonga 実行ファイル</span></a> が実際に使っている <code class="docutils literal notranslate"><span class="pre">grn_thread_*</span></code> APIの使い方です。 <a class="reference internal" href="../executables/groonga.html"><span class="doc">groonga 実行ファイル</span></a> は最大スレッド数を増やすと、スレッドプールのサイズを増やします。一方、 <a class="reference internal" href="../executables/groonga.html"><span class="doc">groonga 実行ファイル</span></a> は最大スレッド数を減らすと、スレッドプールのサイズを減らします。もし、すでに減少後のスレッドプールのサイズ以上のスレッドが動いていたらそれらを止めます。</p>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="k">static</span> <span class="n">grn_mutex</span> <span class="n">q_mutex</span><span class="p">;</span>
<span class="k">static</span> <span class="n">grn_cond</span> <span class="n">q_cond</span><span class="p">;</span>
<span class="k">static</span> <span class="kt">uint32_t</span> <span class="n">nfthreads</span><span class="p">;</span>
<span class="k">static</span> <span class="kt">uint32_t</span> <span class="n">max_nfthreads</span><span class="p">;</span>

<span class="k">static</span> <span class="kt">uint32_t</span>
<span class="nf">groonga_get_thread_limit</span><span class="p">(</span><span class="kt">void</span> <span class="o">*</span><span class="n">data</span><span class="p">)</span>
<span class="p">{</span>
  <span class="k">return</span> <span class="n">max_nfthreads</span><span class="p">;</span>
<span class="p">}</span>

<span class="k">static</span> <span class="kt">void</span>
<span class="nf">groonga_set_thread_limit</span><span class="p">(</span><span class="kt">uint32_t</span> <span class="n">new_limit</span><span class="p">,</span> <span class="kt">void</span> <span class="o">*</span><span class="n">data</span><span class="p">)</span>
<span class="p">{</span>
  <span class="kt">uint32_t</span> <span class="n">i</span><span class="p">;</span>
  <span class="kt">uint32_t</span> <span class="n">current_nfthreads</span><span class="p">;</span>

  <span class="n">MUTEX_LOCK</span><span class="p">(</span><span class="n">q_mutex</span><span class="p">);</span>
  <span class="n">current_nfthreads</span> <span class="o">=</span> <span class="n">nfthreads</span><span class="p">;</span>
  <span class="n">max_nfthreads</span> <span class="o">=</span> <span class="n">new_limit</span><span class="p">;</span>
  <span class="n">MUTEX_UNLOCK</span><span class="p">(</span><span class="n">q_mutex</span><span class="p">);</span>

  <span class="k">if</span> <span class="p">(</span><span class="n">current_nfthreads</span> <span class="o">&gt;</span> <span class="n">new_limit</span><span class="p">)</span> <span class="p">{</span>
    <span class="k">for</span> <span class="p">(</span><span class="n">i</span> <span class="o">=</span> <span class="mi">0</span><span class="p">;</span> <span class="n">i</span> <span class="o">&lt;</span> <span class="n">current_nfthreads</span><span class="p">;</span> <span class="n">i</span><span class="o">++</span><span class="p">)</span> <span class="p">{</span>
      <span class="n">MUTEX_LOCK</span><span class="p">(</span><span class="n">q_mutex</span><span class="p">);</span>
      <span class="n">COND_SIGNAL</span><span class="p">(</span><span class="n">q_cond</span><span class="p">);</span>
      <span class="n">MUTEX_UNLOCK</span><span class="p">(</span><span class="n">q_mutex</span><span class="p">);</span>
    <span class="p">}</span>
  <span class="p">}</span>
<span class="p">}</span>

<span class="kt">int</span>
<span class="nf">main</span><span class="p">(</span><span class="kt">int</span> <span class="n">argc</span><span class="p">,</span> <span class="kt">char</span> <span class="o">*</span><span class="n">argv</span><span class="p">)</span>
<span class="p">{</span>
  <span class="cm">/* ... */</span>
  <span class="n">grn_thread_set_get_limit_func</span><span class="p">(</span><span class="n">groonga_get_thread_limit</span><span class="p">,</span> <span class="nb">NULL</span><span class="p">);</span>
  <span class="n">grn_thread_set_set_limit_func</span><span class="p">(</span><span class="n">groonga_set_thread_limit</span><span class="p">,</span> <span class="nb">NULL</span><span class="p">);</span>

  <span class="n">grn_init</span><span class="p">();</span>

  <span class="cm">/* ... */</span>
<span class="p">}</span>
</pre></div>
</div>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.24.3. </span>リファレンス<a class="headerlink" href="#reference" title="このヘッドラインへのパーマリンク">¶</a></h2>
<dl class="c type">
<dt id="c.grn_thread_get_limit_func">
<em class="property">typedef </em>uint32_t (*<code class="sig-name descname">grn_thread_get_limit_func</code>)<span class="sig-paren">(</span>void *data<span class="sig-paren">)</span><a class="headerlink" href="#c.grn_thread_get_limit_func" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>最大スレッド数を返す関数の型です。</p>
</dd></dl>

<dl class="c type">
<dt id="c.grn_thread_set_limit_func">
<em class="property">typedef </em>void (*<code class="sig-name descname">grn_thread_set_limit_func</code>)<span class="sig-paren">(</span>uint32_t new_limit, void *data<span class="sig-paren">)</span><a class="headerlink" href="#c.grn_thread_set_limit_func" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>最大スレッド数を設定する関数の型です。</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_thread_get_limit">
uint32_t <code class="sig-name descname">grn_thread_get_limit</code><span class="sig-paren">(</span>void<span class="sig-paren">)</span><a class="headerlink" href="#c.grn_thread_get_limit" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>最大スレッド数を返します。</p>
<p><a class="reference internal" href="#c.grn_thread_set_get_limit_func" title="grn_thread_set_get_limit_func"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_thread_set_get_limit_func()</span></code></a> で <a class="reference internal" href="#c.grn_thread_get_limit_func" title="grn_thread_get_limit_func"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_thread_get_limit_func</span></code></a> を設定していない場合は、常に <code class="docutils literal notranslate"><span class="pre">0</span></code> を返します。</p>
<dl class="field-list simple">
<dt class="field-odd">戻り値</dt>
<dd class="field-odd"><p>最大スレッド数または <code class="docutils literal notranslate"><span class="pre">0</span></code> 。</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_thread_set_limit">
void_t <code class="sig-name descname">grn_thread_set_limit</code><span class="sig-paren">(</span>uint32_t <em>new_limit</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_thread_set_limit" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>最大スレッド数を設定します。</p>
<p><a class="reference internal" href="#c.grn_thread_set_set_limit_func" title="grn_thread_set_set_limit_func"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_thread_set_set_limit_func()</span></code></a> で <a class="reference internal" href="#c.grn_thread_set_limit_func" title="grn_thread_set_limit_func"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_thread_set_limit_func</span></code></a> を設定していない場合はなにもしません。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>new_limit</strong> -- 新しい最大スレッド数。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_thread_set_get_limit_func">
void <code class="sig-name descname">grn_thread_set_get_limit_func</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_thread_get_limit_func" title="grn_thread_get_limit_func">grn_thread_get_limit_func</a> <em>func</em>, void *<em>data</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_thread_set_get_limit_func" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>最大スレッド数を返すカスタム関数を設定します。</p>
<p><code class="docutils literal notranslate"><span class="pre">data</span></code> は <a class="reference internal" href="#c.grn_thread_get_limit" title="grn_thread_get_limit"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_thread_get_limit()</span></code></a> が <code class="docutils literal notranslate"><span class="pre">func</span></code> を呼ぶときに <code class="docutils literal notranslate"><span class="pre">func</span></code> に渡されます。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>func</strong> -- 最大スレッド数を返すカスタム関数。</p></li>
<li><p><strong>data</strong> -- <code class="docutils literal notranslate"><span class="pre">func</span></code> が呼ばれるときに <code class="docutils literal notranslate"><span class="pre">func</span></code> に渡されるユーザーのためのデータ。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_thread_set_set_limit_func">
void <code class="sig-name descname">grn_thread_set_set_limit_func</code><span class="sig-paren">(</span><a class="reference internal" href="#c.grn_thread_set_limit_func" title="grn_thread_set_limit_func">grn_thread_set_limit_func</a> <em>func</em>, void *<em>data</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_thread_set_set_limit_func" title="この定義へのパーマリンク">¶</a><br /></dt>
<dd><p>最大スレッド数を設定するカスタム関数を設定します。</p>
<p><code class="docutils literal notranslate"><span class="pre">data</span></code> は <a class="reference internal" href="#c.grn_thread_set_limit" title="grn_thread_set_limit"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_thread_set_limit()</span></code></a> が <code class="docutils literal notranslate"><span class="pre">func</span></code> を呼ぶときに <code class="docutils literal notranslate"><span class="pre">func</span></code> に渡されます。</p>
<dl class="field-list simple">
<dt class="field-odd">パラメータ</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>func</strong> -- 最大スレッド数を設定するカスタム関数。</p></li>
<li><p><strong>data</strong> -- <code class="docutils literal notranslate"><span class="pre">func</span></code> が呼ばれるときに <code class="docutils literal notranslate"><span class="pre">func</span></code> に渡されるユーザーのためのデータ。</p></li>
</ul>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.24. <code class="docutils literal notranslate"><span class="pre">grn_thread_*</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.24.1. 概要</a></li>
<li><a class="reference internal" href="#example">7.25.24.2. 例</a></li>
<li><a class="reference internal" href="#reference">7.25.24.3. リファレンス</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="grn_table_cursor.html"
                        title="前の章へ"><span class="section-number">7.25.23. </span><code class="docutils literal notranslate"><span class="pre">grn_table_cursor</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="grn_type.html"
                        title="次の章へ"><span class="section-number">7.25.25. </span><code class="docutils literal notranslate"><span class="pre">grn_type</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="grn_type.html" title="7.25.25. grn_type"
             >次へ</a> |</li>
        <li class="right" >
          <a href="grn_table_cursor.html" title="7.25.23. grn_table_cursor"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.24. </span><code class="docutils literal notranslate"><span class="pre">grn_thread_*</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>